<?php
/**
 * @package     WT Masonry.js
 * @copyright   (C) 2023 Sergey Tolkachyov <https://web-tolk.ru>
 * @link 		
 * @license     GNU General Public License version 3 or later
 */
namespace Joomla\Plugin\System\Wtmasonryjs\Extension;
 
defined('_JEXEC') or die;

use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\Event\SubscriberInterface;


class Wtmasonryjs extends CMSPlugin implements SubscriberInterface
{
	/**
	 * Load the language file on instantiation.
	 *
	 * @var    boolean
	 *
	 * @since  3.9.0
	 */
	protected $autoloadLanguage = true;
	
	protected $allowLegacyListeners = false;

	/**
	 * @inheritDoc
	 *
	 * @return array
	 *
	 * @since 4.1.0
	 *
	 * @throws Exception
	 */
	public static function getSubscribedEvents(): array
	{

		return $mapping  = [
            'onAfterDispatch' => 'addDeSandroMasonryJsPreset'
        ];
	}


	public function addDeSandroMasonryJsPreset() : void
	{
        $app = $this->getApplication();

		// Only trigger in frontend
		if ($app->isClient('site'))
		{
            $document = $app->getDocument();

            if (!($document instanceof \Joomla\CMS\Document\HtmlDocument))
            {
                return;
            }
			/** @var Joomla\CMS\WebAsset\WebAssetManager $wa */
			$wa = $document->getWebAssetManager();
			$wa->getRegistry()->addRegistryFile('media/plg_system_wtmasonryjs/joomla.asset.json');
		}
	}
}
